--[[
    ----------------------------------------------------------------------------
    App für den Unilog von SM-Modelltechnik
    ----------------------------------------------------------------------------
	MIT License
	
    Copyright (c) 2017 A. Fromm
   
    Hiermit wird unentgeltlich jeder Person, die eine Kopie der Software und der
    zugehörigen Dokumentationen (die "Software") erhält, die Erlaubnis erteilt,
    sie uneingeschränkt zu nutzen, inklusive und ohne Ausnahme mit dem Recht, sie
    zu verwenden, zu kopieren, zu verändern, zusammenzufügen, zu veröffentlichen,
    zu verbreiten, zu unterlizenzieren und/oder zu verkaufen, und Personen, denen
    diese Software überlassen wird, diese Rechte zu verschaffen, unter den
    folgenden Bedingungen: 
    Der obige Urheberrechtsvermerk und dieser Erlaubnisvermerk sind in allen Kopien
    oder Teilkopien der Software beizulegen. 
    DIE SOFTWARE WIRD OHNE JEDE AUSDRÜCKLICHE ODER IMPLIZIERTE GARANTIE BEREITGESTELLT,
    EINSCHLIEßLICH DER GARANTIE ZUR BENUTZUNG FÜR DEN VORGESEHENEN ODER EINEM
    BESTIMMTEN ZWECK SOWIE JEGLICHER RECHTSVERLETZUNG, JEDOCH NICHT DARAUF BESCHRÄNKT.
    IN KEINEM FALL SIND DIE AUTOREN ODER COPYRIGHTINHABER FÜR JEGLICHEN SCHADEN ODER
    SONSTIGE ANSPRÜCHE HAFTBAR ZU MACHEN, OB INFOLGE DER ERFÜLLUNG EINES VERTRAGES,
    EINES DELIKTES ODER ANDERS IM ZUSAMMENHANG MIT DER SOFTWARE ODER SONSTIGER
    VERWENDUNG DER SOFTWARE ENTSTANDEN. 
	----------------------------------------------------------------------------
    
--]]
collectgarbage()
--------------------------------------------------------------------------------
local initAnimation = true
local model, owner = " ", " "
local playDone, sensorId, sensorPa, alarmValue
local sensid1, sensid2, sensid3, sensid4, sensid5 = 0, 0.0, 0, 0.0, 0
local sensid6, sensid7, sensid8, sensid9, sensid10 = 0, 0, 0, 0, 0
local sensid11, sensid12, sensid13, sensid14, sensid15 = 0, 0, 0.00, 0, 0
local sensid16, sensid17, sensid18, sensid19, sensid20 = 0, 0, 0, 0, 0
local capa1, remaining = 0, 0
local minrpm, maxrpm, mincur, maxcur = 0, 0, 99.9, 0.0
local minvtg, maxvtg, mintmp, maxtmp = 0.0, 0.0, 0.0, 0.0
local fTime = {std=0, min=0, sec=0}
local time, lastTime, newTime = 0, 0, 0
local std, min, sec = 0, 0, 0
local tempint = 0.0
local minrxv, maxrxv = 0.0, 0.0

--------------------------------------------------------------------------------
-- Read translations
local function setLanguage()
    local lng=system.getLocale()
    local file = io.readall("Apps/Lang/SMSensor.jsn")
    local obj = json.decode(file)
    if(obj) then
        trans = obj[lng] or obj[obj.default]
    end
end
--------------------------------------------------------------------------------
-- Draw Battery and percentage display
local function drawBattery(Value, Alarm)
		-- Battery
		if (Value) then
			lcd.drawRectangle(134, 55, 52, 103)
			
			lcd.drawFilledRectangle(148, 48, 24, 7)
			chgY = (160 - (Value * 1.03))
			chgH = ((Value * 1.03) - 2)
			lcd.setColor(0, 255, 0)			
			lcd.drawFilledRectangle(135, chgY, 50, chgH)
		else
		  lcd.drawRectangle(134, 55, 52, 103)
			lcd.setColor(0, 255, 0)
	    lcd.drawFilledRectangle(148, 48, 24, 7)
		end
		lcd.setColor(0, 0, 0)
		-- Percentage Display
		if( Value > Alarm ) then	
			lcd.drawRectangle(115, 2, 90, 43, 6)
			lcd.drawRectangle(114, 1, 92, 45, 7)
			lcd.drawText(160 - (lcd.getTextWidth(FONT_MAXI, string.format("%.0f%%",Value)) / 2),4, string.format("%.0f%%",Value),FONT_MAXI)
		else
			if( system.getTime() % 2 == 0 ) then -- blink every second
				lcd.drawRectangle(115, 2, 90, 43, 6)
				lcd.drawRectangle(114, 1, 92, 45, 7)
				lcd.drawText(160 - (lcd.getTextWidth(FONT_MAXI, string.format("%.0f%%",Value)) / 2),4, string.format("%.0f%%",Value),FONT_MAXI)
			end
		end
    collectgarbage()
end
--------------------------------------------------------------------------------
-- Draw left top box
local function drawLetopbox(Value, val2, val3)	-- Drehzahl
		-- draw fixed Text
		lcd.drawText(57 - (lcd.getTextWidth(FONT_MINI,trans.engspeed) / 2),2,trans.engspeed,FONT_MINI)
		lcd.drawText(82, 33, "1/min", FONT_MINI)
		lcd.drawText(6, 50, "Min/Max:", FONT_MINI)

		-- draw Values
		lcd.drawText(80 - lcd.getTextWidth(FONT_MAXI,string.format("%.0f",Value)),13,string.format("%.0f",Value),FONT_MAXI)
        lcd.drawText(60,50, string.format("%.0f - %.0f", val2, val3), FONT_MINI)
		
end
--------------------------------------------------------------------------------
-- Draw left middle box
local function drawLemidbox(Value, val2, val3)	-- Strom Stromsensor
		-- draw fixed Text
		lcd.drawText(57 - (lcd.getTextWidth(FONT_MINI,trans.current) / 2),67,trans.current,FONT_MINI)
		lcd.drawText(102, 97, "A", FONT_MINI)
		lcd.drawText(6, 117, "Min/Max:", FONT_MINI)
		
		-- draw Values
		lcd.drawText(100 - lcd.getTextWidth(FONT_MAXI, string.format("%.1f",Value)),79, string.format("%.1f",Value), FONT_MAXI)
		lcd.drawText(60, 117, string.format("%.1f - %.1f", val2, val3), FONT_MINI)
		
end
--------------------------------------------------------------------------------
-- Draw left bottom box
local function drawLebotbox(Value, val2, val3)	-- Rx Values
		-- draw fixed Text
		lcd.drawText(3, 138, "Rx:", FONT_NORMAL)
		lcd.drawText(56, 138, "V", FONT_NORMAL)
		
        lcd.drawText(67,134,"Max:",FONT_MINI)
        lcd.drawText(67,146,"Min:",FONT_MINI)

		-- draw Value Rx Voltage 
        lcd.drawText(55 - lcd.getTextWidth(FONT_BIG, string.format("%.1f",Value)),135, string.format("%.1f",Value),FONT_BIG)
        -- draw Value Max/Min
        lcd.drawText(95 , 134, string.format("%.1fV",val3), FONT_MINI)
        lcd.drawText(95 , 146, string.format("%.1fV",val2), FONT_MINI)

end
--------------------------------------------------------------------------------
-- Draw right top box
local function drawRitopbox(Value, val2, val3)	-- Akkudaten
		-- draw fixed Text
		lcd.drawText(262 - (lcd.getTextWidth(FONT_MINI,trans.akku) / 2),2,trans.akku,FONT_MINI)
		lcd.drawText(283, 33, "mAh", FONT_MINI)
		lcd.drawText(204, 50, trans.capacity, FONT_MINI)

		-- draw Values
		lcd.drawText(278 - lcd.getTextWidth(FONT_MAXI, string.format("%.0f",Value)),13, string.format("%.0f",Value), FONT_MAXI)
        lcd.drawText(258,50, string.format("%s mAh", val2),FONT_MINI)
		
end
--------------------------------------------------------------------------------
-- Draw right middle box
local function drawRimidbox(Value, val2, val3)	-- Strom
		-- draw fixed Text
		lcd.drawText(258 - (lcd.getTextWidth(FONT_MINI, trans.ftime)/2), 67, trans.ftime, FONT_MINI)
		lcd.drawText(246 - (lcd.getTextWidth(FONT_MINI, trans.date)), 117, trans.date, FONT_MINI)

		
		-- draw Values
        lcd.drawText(258 - (lcd.getTextWidth(FONT_MAXI, string.format("%0d:%02d:%02d", std, min, sec)) / 2), 79, string.format("%0d:%02d:%02d", std, min, sec), FONT_MAXI)
		lcd.drawText(250, 117, string.format("%02d.%02d.%02d", val2.day, val2.mon, val2.year), FONT_MINI)
		
end
--------------------------------------------------------------------------------
-- Draw right bottom box
local function drawRibotbox(vol1, vol2)	-- Rx Values
		-- draw fixed Text
		lcd.drawText(280 - lcd.getTextWidth(FONT_MINI, trans.lowvtg), 134, trans.lowvtg, FONT_MINI)
		lcd.drawText(307, 134, "V", FONT_MINI)
		
        lcd.drawText(280 - lcd.getTextWidth(FONT_MINI, trans.lowcell),146,trans.lowcell,FONT_MINI)
    --    lcd.drawText(298,145,"%",FONT_MINI)

		-- draw Value lowest Voltage 
        lcd.drawText(304 - lcd.getTextWidth(FONT_MINI,string.format("%.2f",vol1)),134,string.format("%.2f",vol1),FONT_MINI)
        -- draw Value # lowest cell
        lcd.drawText(304 - lcd.getTextWidth(FONT_MINI,string.format("%.0f",vol2)),146,string.format("%.0f",vol2),FONT_MINI)

end
--------------------------------------------------------------------------------
-- Telemetriefenster Page1
local function Page1(width, height)

		-- animation demo at startup - fill tank up
		if( initAnimation ) then
			remaining = remaining - 5
			if remaining <= 0  then
				initAnimation = false
			end
		end	

		-- Set max/min percentage to 99/0 for drawing
		if( remaining > 99 ) then remaining = 99 end
		if( remaining < 0 ) then remaining = 0 end

		drawBattery(remaining, alarmValue)
		drawLetopbox(sensid7, minrpm, maxrpm)	--Variablen sind aktuelle Drehzahl, Minimaldrehzahl, Maximaldrehzahl
		drawLemidbox(sensid2, mincur, maxcur)	--Variablen sind aktueller Strom, Minimalstrom, Maximalstrom im Stringformat
		drawLebotbox(sensid4, minrxv, maxrxv)	--Variablen sind Empfängerspannung
		drawRitopbox(sensid3, capa1, 0)	--Variablen sind Verbrauchte Kapazität, Akkukapazität, Null
		drawRimidbox("fTime", today, 0)	--Variablen sind Flugzeit, Datum, Null
		drawRibotbox(sensid13, sensid14)	--Variablen sind niedrigste Zellspannung, Nummer der Zelle mit niedrigster Spannung, Null
	
		-- draw horizontal lines
		lcd.drawFilledRectangle(4, 64, 116, 2)
		lcd.drawFilledRectangle(4, 130, 116, 2)
		lcd.drawFilledRectangle(200, 64, 116, 2)
		lcd.drawFilledRectangle(200, 130, 116, 2)
end
--------------------------------------------------------------------------------
-- Take care of user's settings-changes
local function sensorChanged(value)
	sensorId  = sensorsAvailable[value].id
	system.pSave("sensorId", sensorId)
end

local function capa1Changed(value)
	capa1 = value
	system.pSave("capa1", capa1)
end

local function alarmValueChanged(value)
    alarmValue = value
    system.pSave("alarmValue", alarmValue)
end

local function alarmVoiceChanged(value)
    alarmVoice = value
    system.pSave("alarmVoice", alarmVoice)
end

local function timeSwChanged(value)
    timeSw = value
    system.pSave("timeSw", timeSw)
end

local function resSwChanged(value)
    resSw = value
    system.pSave("resSw", resSw)
end
--------------------------------------------------------------------------------
local function setupForm(formID)
    -- List sensors only if menu is active to preserve memory at runtime 
    -- (measured up to 25% save if menu is not opened)
    sensorsAvailable = {}
  local available = system.getSensors();
  local list={}
  local curIndex=-1
  local descr = ""
  for index,sensor in ipairs(available) do 
    if(sensor.param == 0) then
      list[#list+1] = sensor.label
      sensorsAvailable[#sensorsAvailable+1] = sensor
      if(sensor.id==sensorId ) then
        curIndex=#sensorsAvailable
      end 
    end
    end 
    
    local form, addRow, addLabel = form, form.addRow ,form.addLabel
    local addIntbox, addSelectbox = form.addIntbox, form.addSelectbox
    local addInputbox, addCheckbox = form.addInputbox, form.addCheckbox
    local addAudioFilebox, setButton = form.addAudioFilebox, form.setButton
	local setTitle, addSpacer = form.setTitle, form.addSpacer
    
	setTitle(trans.title)
				
	addSpacer(318,7)		

    addRow(2)
    addLabel({label = trans.selectsens, width=200})
    addSelectbox(list, curIndex, true, sensorChanged)
    
	addSpacer(318,7)		

    addRow(1)
    addLabel({label=trans.labelAlarm,font=FONT_BOLD})
    
    addRow(2)
    addLabel({label=trans.capa1, width=230})
    addIntbox(capa1, 0, 32767, 0, 0, 10, capa1Changed)
    
    addRow(2)
    addLabel({label=trans.alarmValue, width=230})
    addIntbox(alarmValue, 0, 100, 0, 0, 1, alarmValueChanged)
    
    form.addRow(2)
    addLabel({label=trans.voiceFile})
    addAudioFilebox(alarmVoice, alarmVoiceChanged)
	
	addSpacer(318,7)		

	addRow(2)
	addLabel({label=trans.timeSw})
	addInputbox(timeSw,true,timeSwChanged)
	
	addRow(2)
	addLabel({label=trans.resSw})
	addInputbox(resSw,true,resSwChanged)
	
	addSpacer(318,7)		

	addRow(1)
	addLabel({label="Powered by A. Fromm "..Version.." ", font=FONT_MINI, alignRight=true})
    
    collectgarbage()
end
--------------------------------------------------------------------------------
-- Fligt time
local function FlightTime()
	newTime = system.getTimeCounter()
	ltimeSw = system.getInputsVal(timeSw)
	resetSw = system.getInputsVal(resSw)

	if (ltimeSw ~= 1 and resetSw == 1) then time = 0 end
	
	if (ltimeSw == 1) then		
		if newTime > (lastTime + 1000) then  -- nach einer sec.
			lastTime = newTime
			time = time + 1
		end
	end	
	std = math.floor(time / 3600)
	min = math.floor(time / 60) - std * 60
	sec = time - min * 60
end
---------------------------------------------------------------------------------
local function loop()

		local P8 = ((system.getInputs("P8") + 1) / 2) * 100	--Nur zum Testen!!!

		-- Aufruf Flugzeit
		FlightTime()

		-- Read Sensor ID 1 Spannung Stromsensor
		sensor = system.getSensorByID(sensorId, 1)
		if(sensor and sensor.valid) then sensid1 = sensor.value
		-- calculate Min/Max Sensor 1
			if sensid1 < minvtg then minvtg = sensid1 end
			if sensid1 > maxvtg then maxvtg = sensid1 end
		end

		-- Read Sensor ID 2 Strom Stromsensor
		sensor = system.getSensorByID(sensorId, 2)
		if(sensor and sensor.valid) then sensid2 = sensor.value
			-- calculate Min/Max Sensor 2
			if sensid2 < mincur then mincur = sensid2 end
			if sensid2 > maxcur then maxcur = sensid2 end
		end

		-- Read Sensor ID 3 verbrauchte Kapazität
		sensor = system.getSensorByID(sensorId, 3)
		if(sensor and sensor.valid) then sensid3 = sensor.value
			remaining = (((capa1 - sensor.value) * 100) / capa1)		
			-- If we have consumed more than allowed sound alarmValue
			if(not playDone and remaining <= alarmValue and alarmVoice ~= "..." and sensor and sensor.valid) then
				system.playFile(alarmVoice,AUDIO_QUEUE)
				system.playNumber(remaining, 0, "%")
				playDone = true   
			end
			-- If we are above consumption alarm-level enable alarm
			if(remaining > alarmValue) then playDone = false
			end
		end	

		-- Read Sensor ID 4 Empfängerspannung
		sensor = system.getSensorByID(sensorId, 4)
		if(sensor and sensor.valid) then sensid4 = sensor.value
			if sensid4 < minrxv then minrxv = sensid4 end
			if sensid4 > maxrxv then maxrxv = sensid4 end
		end

		-- Read Sensor ID 5 Höhe 
		sensor = system.getSensorByID(sensorId, 5)
		if(sensor and sensor.valid) then sensid5 = sensor.value end
		
		-- Read Sensor ID 6 Vario
		sensor = system.getSensorByID(sensorId, 6)
		if(sensor and sensor.valid) then sensid6 = sensor.value end

		-- Read Sensor ID 7 Drehzahl
		sensor = system.getSensorByID(sensorId, 7)
		if(sensor and sensor.valid) then sensid7 = sensor.value
			-- calculate Min/Max Sensor 7
			if sensid7 < minrpm then minrpm = sensid7 end
			if sensid7 > maxrpm then maxrpm = sensid7 end
		end

		-- Read Sensor ID 8 Energie
		sensor = system.getSensorByID(sensorId, 8)
		if(sensor and sensor.valid) then sensid8 = sensor.value end

		-- Read Sensor ID 9 Leistung
		sensor = system.getSensorByID(sensorId, 9)
		if(sensor and sensor.valid) then sensid9 = sensor.value end

		-- Read Sensor ID 10 Luftdruck
		sensor = system.getSensorByID(sensorId, 10)
		if(sensor and sensor.valid) then sensid10 = sensor.value end

		-- Read Sensor ID 11 Impuls ein
		sensor = system.getSensorByID(sensorId, 11)
		if(sensor and sensor.valid) then sensid11 = sensor.value end

		-- Read Sensor ID 12 Impuls aus
		sensor = system.getSensorByID(sensorId, 12)
		if(sensor and sensor.valid) then sensid12 = sensor.value end
		
		-- Read Sensor ID 13 Zelle min
		sensor = system.getSensorByID(sensorId, 13)
		if(sensor and sensor.valid) then sensid13 = sensor.value end

		-- Read Sensor ID 14 #Zelle min
		sensor = system.getSensorByID(sensorId, 14)
		if(sensor and sensor.valid) then sensid14 = sensor.value end

		-- Read Sensor ID 15 Eingang A1
		sensor = system.getSensorByID(sensorId, 15)
		if(sensor and sensor.valid) then sensid15 = sensor.value end

		-- Read Sensor ID 16 Eingang A2
		sensor = system.getSensorByID(sensorId, 16)
		if(sensor and sensor.valid) then sensid16 = sensor.value end

		-- Read Sensor ID 17 Eingang A3
		sensor = system.getSensorByID(sensorId, 17)
		if(sensor and sensor.valid) then sensid17 = sensor.value end
		
		-- Read Sensor ID 18 Temperatur intern
		sensor = system.getSensorByID(sensorId, 18)
		if(sensor and sensor.valid) then sensid18 = sensor.value
			-- calculate Min/Max Sensor 18
			if sensid18 < mintmp then mintmp = sensid18 end
			if sensid18 > maxtmp then maxtmp = sensid18 end
		end

		-- Read Sensor ID 19 Höhengewinn
		sensor = system.getSensorByID(sensorId, 19)
		if(sensor and sensor.valid) then sensid19 = sensor.value end

		-- Read Sensor ID 20 Restkapazität
		sensor = system.getSensorByID(sensorId, 20)
		if(sensor and sensor.valid) then sensid20 = sensor.value end
		
   collectgarbage()
   
end
--------------------------------------------------------------------------------
local function init(code1)
    local pLoad, registerForm, registerTelemetry = system.pLoad, system.registerForm, system.registerTelemetry
	remaining = 100
	model = system.getProperty("Model")
	owner = system.getUserName()
	today = system.getDateTime()
	sensorId = pLoad("sensorId", 0)
	capa1 = pLoad("capa1",0)
    alarmValue = pLoad("alarmValue", 0)
    alarmVoice = pLoad("alarmVoice", "...")
	timeSw = pLoad("timeSw")
	resSw = pLoad("resSw")
    registerForm(1, MENU_APPS, trans.appName1, setupForm)
    registerTelemetry(1, trans.appName1.." "..model, 4, Page1) --registers a full size Window
--    registerTelemetry(2, xstrans.appName2.." "..model, 4, page2) --registers a full size Window
    collectgarbage()
end
--------------------------------------------------------------------------------
Version = "0.1"
setLanguage()
collectgarbage()
return {init=init, loop=loop, author="A. Fromm", version=Version, name=trans.appName1}